/* vi: expandtab:softtabstop=4:tabstop=4:cindent:cino=>4,g4,h4,+4,c1,C4,(4,u4,^-0,{2,}0
 */
/*

Copyright (c) 2008, SFB/TR-55
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

   * Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.

   * Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in
     the documentation and/or other materials provided with the
     distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 */

#ifndef QUEUES_H_
#define QUEUES_H_

#include <unistd.h>

typedef struct queue {
    unsigned char * data;
    size_t index;
    size_t depth;
    size_t expands;
} queue_t;

queue_t * create_queue(size_t depth);

void expand_queue(queue_t * q, size_t extra);

void obliviate_queue(queue_t ** q);

int fill_queue(queue_t * q, void* buffer, size_t len);

int void_queue(queue_t * q, size_t len);

void hexdump_queue(queue_t * q);

ssize_t read_into_queue(queue_t * q, int fd, size_t len);

static inline size_t left_queue(queue_t * q)
{
    if (q->expands) {
        return q->expands - q->index;
    }
    return q->depth - q->index;
}

static inline size_t in_queue(queue_t * q)
{
    return q->index;
}

static inline unsigned char * data_queue(queue_t * q)
{
    return q->data;
}

#endif /* QUEUES */
